// Gallery.cpp

#include "stdafx.h"
#include "Gallery.h"
#include "DTree.h"
#include <conio.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CWinApp theApp;

static const CString FileName("/Gallery.htm");

static const CString Header("\
<!doctype html public \"-//W3C//DTD HTML 3.2//EN\">\r\n\
<html>\r\n\
<head>\r\n\
<title>Gallery</title>\r\n\
  <meta http-equiv=\"Content-Type\" content=\"text/html; charset=windows-1252\">\r\n\
</head>\r\n\
\r\n\
<body><font face=\"arial,helvetica\" size=2>\r\n\
<center>\r\n\
<h1>GALLERY</h1>\r\n\
<font size=1><small>Click an image to enlarge it</small></font><br>\r\n\
<h2>");

static const CString Footer("\
</center>\r\n\
</body>\r\n\
</html>\r\n");

class CGallery : public CDTreeBehaviour {
  bool    FirstFile;
  char    Count;
public:
  CGallery() {
    char Path[_MAX_PATH];
    GetCurrentDirectory(sizeof Path, Path);
    CDTree(Path, *this);

#ifndef ASP
    HKEY Key;
    if(RegOpenKeyEx(HKEY_CLASSES_ROOT,".htm",0,KEY_READ,&Key)==ERROR_SUCCESS) {
      DWORD dwSize=2*MAX_PATH;
      char Browser[2*MAX_PATH];
      if(RegQueryValueEx(Key,"",NULL,NULL,(BYTE*)&Browser,&dwSize)==ERROR_SUCCESS) {
        RegCloseKey(Key);
        strcat(Browser, "\\shell\\open\\command");
        if(RegOpenKeyEx(HKEY_CLASSES_ROOT,Browser,0,KEY_READ,&Key)==ERROR_SUCCESS) {
          dwSize=2*MAX_PATH;
          if(RegQueryValueEx(Key,"",NULL,NULL,(BYTE*)&Browser,&dwSize)==ERROR_SUCCESS) {
            for(char* it=Path; *it; ++it) if(*it=='\\') *it='/';
            CString cmd(Browser);
            if(cmd.Find("%1")!=-1) cmd.Replace("%1",CString("file://")+Path+FileName);
            else cmd+=CString(" \"file://")+Path+FileName+"\"";
            WinExec(cmd, SW_SHOWNORMAL);
      } } }
      RegCloseKey(Key);
    }
#endif //def ASP
  }

  CString GetExtension(CString S) {
    int i=S.ReverseFind('.');
    if(i!=-1) S=S.Mid(i);
    S.MakeLower();
    return S;
  }

  void OnDIR (CDTreeBase& DTree) {FirstFile=true;}
  void OnUp  (CDTreeBase& DTree) {FirstFile=true;}
  void OnFile(CDTreeBase& DTree) {
    if(!FirstFile) return;
    FirstFile=false;
    puts(DTree.GetPath());
    try {
      CFile File;
      if(File.Open(DTree.GetPath()+FileName,CFile::modeCreate|CFile::modeWrite|CFile::shareDenyNone)) {
        CArchive ar(&File, CArchive::store);
        ar.WriteString(
#ifdef ASP
          ASPHeader+
#endif //def ASP
          Header+DTree.GetCurrentDirectoryName()+"</h2>\r\n");
        bool FirstPass=true;
        bool EmptyFolder=true;
        for(CTreeListIterator<CFO> it=((CDTree*)&DTree)->GetIterator(); it; ++it) {
          char* Tick=".o*O";
          putch(Tick[(++Count)&3]);
          putch('\r');
          CString Name(it->GetName());
          Name.Replace('\\','/');
          if(it->IsDirectory()) {
            ar.WriteString(CString("[<a href=\"")+Name+FileName+"\">"+Name+"</a>]\r\n");
            continue;
          }
          if(FirstPass) {
            FirstPass=false;
            ar.WriteString("<p>\r\n");
          }
          CString Ext(GetExtension((*it).GetName()));
          if(!Ext.CompareNoCase(".gif")
          || !Ext.CompareNoCase(".jpg")
          || !Ext.CompareNoCase(".jpeg")
          || !Ext.CompareNoCase(".png")
          || !Ext.CompareNoCase(".bmp")
          || !Ext.CompareNoCase(".swf")
          ) {
            EmptyFolder=false;
            ar.WriteString(CString("<a href=\""+Name+"\"><img border=0 height=200 src=\"")+Name+"\" alt=\""+Name+"\"></a>\r\n");
//          ar.WriteString(CString("<a href=\""+Name+"\"><img border=0 height=200 src=\"")+Name+"\" alt=\""+CFO::FormatPath(DTree.GetPath())+it->GetName()+"\"></a>\r\n");
        } }
        ar.WriteString("<p>\r\n");
        if(EmptyFolder) ar.WriteString("(No Images)\r\n");
        ar.WriteString(Footer);
      }else puts("Gallery.htm couldn't be created.");
    }catch(...) {puts("Out of disk space writing Name.bat");}
  } 
};

int __cdecl _tmain(int argc, TCHAR* argv[], TCHAR* envp[]) {
  if(!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0)) return 1; // initialize MFC
  CGallery();
  return 0;
}
